freedombone-app-gnusocial 45KB

12345678910111213141516171819202122232425262728293031323334353637383940414243444546474849505152535455565758596061626364656667686970717273747576777879808182838485868788899091929394959697989910010110210310410510610710810911011111211311411511611711811912012112212312412512612712812913013113213313413513613713813914014114214314414514614714814915015115215315415515615715815916016116216316416516616716816917017117217317417517617717817918018118218318418518618718818919019119219319419519619719819920020120220320420520620720820921021121221321421521621721821922022122222322422522622722822923023123223323423523623723823924024124224324424524624724824925025125225325425525625725825926026126226326426526626726826927027127227327427527627727827928028128228328428528628728828929029129229329429529629729829930030130230330430530630730830931031131231331431531631731831932032132232332432532632732832933033133233333433533633733833934034134234334434534634734834935035135235335435535635735835936036136236336436536636736836937037137237337437537637737837938038138238338438538638738838939039139239339439539639739839940040140240340440540640740840941041141241341441541641741841942042142242342442542642742842943043143243343443543643743843944044144244344444544644744844945045145245345445545645745845946046146246346446546646746846947047147247347447547647747847948048148248348448548648748848949049149249349449549649749849950050150250350450550650750850951051151251351451551651751851952052152252352452552652752852953053153253353453553653753853954054154254354454554654754854955055155255355455555655755855956056156256356456556656756856957057157257357457557657757857958058158258358458558658758858959059159259359459559659759859960060160260360460560660760860961061161261361461561661761861962062162262362462562662762862963063163263363463563663763863964064164264364464564664764864965065165265365465565665765865966066166266366466566666766866967067167267367467567667767867968068168268368468568668768868969069169269369469569669769869970070170270370470570670770870971071171271371471571671771871972072172272372472572672772872973073173273373473573673773873974074174274374474574674774874975075175275375475575675775875976076176276376476576676776876977077177277377477577677777877978078178278378478578678778878979079179279379479579679779879980080180280380480580680780880981081181281381481581681781881982082182282382482582682782882983083183283383483583683783883984084184284384484584684784884985085185285385485585685785885986086186286386486586686786886987087187287387487587687787887988088188288388488588688788888989089189289389489589689789889990090190290390490590690790890991091191291391491591691791891992092192292392492592692792892993093193293393493593693793893994094194294394494594694794894995095195295395495595695795895996096196296396496596696796896997097197297397497597697797897998098198298398498598698798898999099199299399499599699799899910001001100210031004100510061007100810091010101110121013101410151016101710181019102010211022102310241025102610271028102910301031103210331034103510361037103810391040104110421043104410451046104710481049105010511052105310541055105610571058105910601061106210631064106510661067106810691070107110721073107410751076107710781079108010811082108310841085108610871088108910901091109210931094109510961097109810991100110111021103110411051106110711081109111011111112111311141115111611171118111911201121112211231124112511261127
  1. #!/bin/bash
  2. #
  3. # .---. . .
  4. # | | |
  5. # |--- .--. .-. .-. .-.| .-. .--.--. |.-. .-. .--. .-.
  6. # | | (.-' (.-' ( | ( )| | | | )( )| | (.-'
  7. # ' ' --' --' -' - -' ' ' -' -' -' ' - --'
  8. #
  9. # Freedom in the Cloud
  10. #
  11. # gnusocial application
  12. #
  13. # License
  14. # =======
  15. #
  16. # Copyright (C) 2014-2016 Bob Mottram <bob@freedombone.net>
  17. #
  18. # This program is free software: you can redistribute it and/or modify
  19. # it under the terms of the GNU Affero General Public License as published by
  20. # the Free Software Foundation, either version 3 of the License, or
  21. # (at your option) any later version.
  22. #
  23. # This program is distributed in the hope that it will be useful,
  24. # but WITHOUT ANY WARRANTY; without even the implied warranty of
  25. # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  26. # GNU Affero General Public License for more details.
  27. #
  28. # You should have received a copy of the GNU Affero General Public License
  29. # along with this program. If not, see <http://www.gnu.org/licenses/>.
  30. VARIANTS='full full-vim media'
  31. IN_DEFAULT_INSTALL=0
  32. SHOW_ON_ABOUT=1
  33. GNUSOCIAL_DOMAIN_NAME=
  34. GNUSOCIAL_CODE=
  35. GNUSOCIAL_ONION_PORT=8087
  36. GNUSOCIAL_REPO="https://git.gnu.io/gnu/gnu-social.git"
  37. GNUSOCIAL_COMMIT='7d67eefdf501f492e29f59971ac288e0414dc5b0'
  38. GNUSOCIAL_ADMIN_PASSWORD=
  39. GNUSOCIAL_THEME_REPO="https://git.gnu.io/h2p/Qvitter.git"
  40. GNUSOCIAL_THEME_COMMIT='a7f82628402db3a7579bb9b2877da3c5737da77b'
  41. GNUSOCIAL_WELCOME_MESSAGE=$'<h1>Welcome to GNU Social – a federated social metwork</h1><p>Another Freedombone site</p>'
  42. GNUSOCIAL_BACKGROUND_IMAGE_URL=
  43. GNUSOCIAL_MARKDOWN_REPO="https://git.gnu.io/chimo/markdown.git"
  44. GNUSOCIAL_MARKDOWN_COMMIT='03c53942f94b3376f0946e6e1fe566cc21ccf232'
  45. # Sharings plugin for gnusocial
  46. SHARINGS_REPO="http://git.lasindias.club/bashrc/Sharings"
  47. SHARINGS_COMMIT='d5c6c7f855d9afff9086c09ea706f38c859bc0d4'
  48. SHARINGS_THEME_REPO="http://git.lasindias.club/manuel/SharingsTheme"
  49. SHARINGS_THEME_COMMIT='7106c7ef03'
  50. # NSFW plugin
  51. GNUSOCIAL_NSFW_REPO="https://gitgud.io/ShitposterClub/SensitiveContent"
  52. GNUSOCIAL_NSFW_COMMIT='a096bbe0cfae9a9b177682920ffb58d32a48e136'
  53. # script which causes old posts to expire
  54. gnusocial_expire_script=/usr/bin/gnusocial-expire
  55. gnusocial_variables=(ONION_ONLY
  56. GNUSOCIAL_DOMAIN_NAME
  57. GNUSOCIAL_CODE
  58. GNUSOCIAL_WELCOME_MESSAGE
  59. GNUSOCIAL_BACKGROUND_IMAGE_URL
  60. DDNS_PROVIDER
  61. GNUSOCIAL_MARKDOWN_REPO
  62. GNUSOCIAL_MARKDOWN_COMMIT
  63. SHARINGS_REPO
  64. SHARINGS_COMMIT
  65. SHARINGS_THEME_REPO
  66. SHARINGS_THEME_COMMIT
  67. MY_USERNAME)
  68. function gnusocial_fix_endless_reloads {
  69. # This fixes a bug introduced with commit 5f7032dfee1fd202c14e76a9f8b37af35d584901
  70. # and which causes OrFox to endlessly reload the page
  71. sed -i 's| && common_local_referer()||g' /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/lib/apiauthaction.php
  72. }
  73. function remove_user_gnusocial {
  74. remove_username="$1"
  75. ${PROJECT_NAME}-pass -u $remove_username --rmapp gnusocial
  76. function_check get_completion_param
  77. GNUSOCIAL_DOMAIN_NAME=$(get_completion_param "gnusocial domain")
  78. if [ -d /var/www/$GNUSOCIAL_DOMAIN_NAME ]; then
  79. cd /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs
  80. php scripts/deleteprofile.php -n $remove_username -y
  81. fi
  82. }
  83. function add_user_gnusocial {
  84. new_username="$1"
  85. new_user_password="$2"
  86. ${PROJECT_NAME}-pass -u $new_username -a gnusocial -p "$new_user_password"
  87. GNUSOCIAL_DOMAIN_NAME=$(get_completion_param "gnusocial domain")
  88. if [ -d /var/www/${GNUSOCIAL_DOMAIN_NAME}/htdocs ]; then
  89. cd /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs
  90. php scripts/registeruser.php -n $new_username -w "$new_user_password" -e "$new_username@$HOSTNAME"
  91. ${PROJECT_NAME}-addemail -u $new_username -e "noreply@$GNUSOCIAL_DOMAIN_NAME" -g gnusocial --public no
  92. echo '0'
  93. else
  94. echo '1'
  95. fi
  96. }
  97. function install_interactive_gnusocial {
  98. if [ ! $ONION_ONLY ]; then
  99. ONION_ONLY='no'
  100. fi
  101. if [[ $ONION_ONLY != "no" ]]; then
  102. GNUSOCIAL_DOMAIN_NAME='gnusocial.local'
  103. else
  104. GNUSOCIAL_DETAILS_COMPLETE=
  105. while [ ! $GNUSOCIAL_DETAILS_COMPLETE ]
  106. do
  107. data=$(tempfile 2>/dev/null)
  108. trap "rm -f $data" 0 1 2 5 15
  109. if [[ $DDNS_PROVIDER == "default@freedns.afraid.org" ]]; then
  110. dialog --backtitle $"Freedombone Configuration" \
  111. --title $"GNU Social Configuration" \
  112. --form $"\nPlease enter your GNU Social details. Welcome message and background image URL can be left blank.\n\nIMPORTANT: This should be a domain name which is supported by Let's Encrypt:" 16 65 4 \
  113. $"Domain:" 1 1 "$(grep 'GNUSOCIAL_DOMAIN_NAME' temp.cfg | awk -F '=' '{print $2}')" 1 25 33 40 \
  114. $"Welcome Message:" 2 1 "$(grep '$GNUSOCIAL_WELCOME_MESSAGE' temp.cfg | awk -F '=' '{print $2}')" 2 25 255 255 \
  115. $"Background image URL:" 3 1 "$(grep '$GNUSOCIAL_BACKGROUND_IMAGE_URL' temp.cfg | awk -F '=' '{print $2}')" 3 25 255 255 \
  116. $"Code:" 4 1 "$(grep 'GNUSOCIAL_CODE' temp.cfg | awk -F '=' '{print $2}')" 4 25 33 255 \
  117. 2> $data
  118. else
  119. dialog --backtitle $"Freedombone Configuration" \
  120. --title $"GNU Social Configuration" \
  121. --form $"\nPlease enter your GNU Social details. Welcome message and background image URL can be left blank.\n\nIMPORTANT: This should be a domain name which is supported by Let's Encrypt:" 16 65 4 \
  122. $"Domain:" 1 1 "$(grep 'GNUSOCIAL_DOMAIN_NAME' temp.cfg | awk -F '=' '{print $2}')" 1 25 33 40 \
  123. $"Welcome Message:" 2 1 "$(grep '$GNUSOCIAL_WELCOME_MESSAGE' temp.cfg | awk -F '=' '{print $2}')" 2 25 255 255 \
  124. $"Background image URL:" 3 1 "$(grep '$GNUSOCIAL_BACKGROUND_IMAGE_URL' temp.cfg | awk -F '=' '{print $2}')" 3 25 255 255 \
  125. 2> $data
  126. fi
  127. sel=$?
  128. case $sel in
  129. 1) exit 1;;
  130. 255) exit 1;;
  131. esac
  132. GNUSOCIAL_DOMAIN_NAME=$(cat $data | sed -n 1p)
  133. welcome_msg=$(cat $data | sed -n 2p)
  134. if [ ${#welcome_msg} -gt 1 ]; then
  135. GNUSOCIAL_WELCOME_MESSAGE=$welcome_msg
  136. fi
  137. img_url=$(cat $data | sed -n 3p)
  138. if [ ${#img_url} -gt 1 ]; then
  139. GNUSOCIAL_BACKGROUND_IMAGE_URL=$img_url
  140. fi
  141. if [ $GNUSOCIAL_DOMAIN_NAME ]; then
  142. if [[ $GNUSOCIAL_DOMAIN_NAME == "$HUBZILLA_DOMAIN_NAME" ]]; then
  143. GNUSOCIAL_DOMAIN_NAME=""
  144. fi
  145. TEST_DOMAIN_NAME=$GNUSOCIAL_DOMAIN_NAME
  146. validate_domain_name
  147. if [[ $TEST_DOMAIN_NAME != $GNUSOCIAL_DOMAIN_NAME ]]; then
  148. GNUSOCIAL_DOMAIN_NAME=
  149. dialog --title $"Domain name validation" --msgbox "$TEST_DOMAIN_NAME" 15 50
  150. else
  151. if [[ $DDNS_PROVIDER == "default@freedns.afraid.org" ]]; then
  152. GNUSOCIAL_CODE=$(cat $data | sed -n 4p)
  153. validate_freedns_code "$GNUSOCIAL_CODE"
  154. if [ ! $VALID_CODE ]; then
  155. GNUSOCIAL_DOMAIN_NAME=
  156. fi
  157. fi
  158. fi
  159. fi
  160. if [ $GNUSOCIAL_DOMAIN_NAME ]; then
  161. GNUSOCIAL_DETAILS_COMPLETE="yes"
  162. fi
  163. done
  164. # remove any invalid characters
  165. if [ ${#GNUSOCIAL_WELCOME_MESSAGE} -gt 0 ]; then
  166. new_welcome=$(echo "$GNUSOCIAL_WELCOME_MESSAGE" | sed "s|'||g")
  167. GNUSOCIAL_WELCOME_MESSAGE="$new_welcome"
  168. fi
  169. # save the results in the config file
  170. write_config_param "GNUSOCIAL_CODE" "$GNUSOCIAL_CODE"
  171. write_config_param "GNUSOCIAL_WELCOME_MESSAGE" "$GNUSOCIAL_WELCOME_MESSAGE"
  172. write_config_param "GNUSOCIAL_BACKGROUND_IMAGE_URL" "$GNUSOCIAL_BACKGROUND_IMAGE_URL"
  173. fi
  174. write_config_param "GNUSOCIAL_DOMAIN_NAME" "$GNUSOCIAL_DOMAIN_NAME"
  175. APP_INSTALLED=1
  176. }
  177. function change_password_gnusocial {
  178. curr_username="$1"
  179. new_user_password="$2"
  180. read_config_param ${GNUSOCIAL_DOMAIN_NAME}
  181. cd /var/www/${GNUSOCIAL_DOMAIN_NAME}/htdocs/scripts
  182. php setpassword.php "$curr_username" "$new_user_password"
  183. ${PROJECT_NAME}-pass -u "$curr_username" -a gnusocial -p "$new_user_password"
  184. }
  185. function gnusocial_create_database {
  186. if [ -f $IMAGE_PASSWORD_FILE ]; then
  187. GNUSOCIAL_ADMIN_PASSWORD="$(printf `cat $IMAGE_PASSWORD_FILE`)"
  188. else
  189. if [ ! $GNUSOCIAL_ADMIN_PASSWORD ]; then
  190. GNUSOCIAL_ADMIN_PASSWORD="$(create_password ${MINIMUM_PASSWORD_LENGTH})"
  191. fi
  192. fi
  193. if [ ! $GNUSOCIAL_ADMIN_PASSWORD ]; then
  194. return
  195. fi
  196. function_check create_database
  197. create_database gnusocial "$GNUSOCIAL_ADMIN_PASSWORD" $MY_USERNAME
  198. }
  199. function gnusocial_running_script {
  200. # check that the daemon is running
  201. echo '#!/bin/bash' > /etc/cron.hourly/gnusocial-daemons
  202. echo 'daemon_lines=$(ps aux | grep "scripts/queuedaemon.php" | grep "/var/www")' >> /etc/cron.hourly/gnusocial-daemons
  203. echo 'if [[ $daemon_lines != *"/var/www/"* ]]; then' >> /etc/cron.hourly/gnusocial-daemons
  204. echo " ADMIN_USER=\$(cat $COMPLETION_FILE | grep 'Admin user' | awk -F ':' '{print \$2}')" >> /etc/cron.hourly/gnusocial-daemons
  205. echo ' MY_EMAIL_ADDRESS=$ADMIN_USER@$HOSTNAME' >> /etc/cron.hourly/gnusocial-daemons
  206. echo ' echo "Restarting GNU Social daemons" | mail -s "GNU Social daemons not found" $MY_EMAIL_ADDRESS' >> /etc/cron.hourly/gnusocial-daemons
  207. echo " cd /var/www/${GNUSOCIAL_DOMAIN_NAME}/htdocs" >> /etc/cron.hourly/gnusocial-daemons
  208. echo ' scripts/startdaemons.sh' >> /etc/cron.hourly/gnusocial-daemons
  209. echo 'fi' >> /etc/cron.hourly/gnusocial-daemons
  210. chmod +x /etc/cron.hourly/gnusocial-daemons
  211. }
  212. function reconfigure_gnusocial {
  213. echo -n ''
  214. }
  215. function gnusocial_set_background_image_from_url {
  216. GNUSOCIAL_BACKGROUND_IMAGE_URL_EXT=
  217. if [ $GNUSOCIAL_BACKGROUND_IMAGE_URL ]; then
  218. if [[ $GNUSOCIAL_BACKGROUND_IMAGE_URL == *".jpeg" || $GNUSOCIAL_BACKGROUND_IMAGE_URL == *".jpg" ]]; then
  219. GNUSOCIAL_BACKGROUND_IMAGE_URL_EXT="jpg"
  220. fi
  221. if [[ $GNUSOCIAL_BACKGROUND_IMAGE_URL == *".png" ]]; then
  222. GNUSOCIAL_BACKGROUND_IMAGE_URL_EXT="png"
  223. fi
  224. if [[ $$GNUSOCIAL_BACKGROUND_IMAGE_URL == *".gif" ]]; then
  225. GNUSOCIAL_BACKGROUND_IMAGE_URL_EXT="gif"
  226. fi
  227. fi
  228. if [ $GNUSOCIAL_BACKGROUND_IMAGE_URL_EXT ]; then
  229. read_config_param GNUSOCIAL_DOMAIN_NAME
  230. gnusocial_config_file=/var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/config.php
  231. cd /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/local/plugins/Qvitter
  232. wget $GNUSOCIAL_BACKGROUND_IMAGE_URL -O img/custom.${GNUSOCIAL_BACKGROUND_IMAGE_URL_EXT}
  233. if [ ! -f img/custom.${GNUSOCIAL_BACKGROUND_IMAGE_URL_EXT} ]; then
  234. echo "$GNUSOCIAL_BACKGROUND_IMAGE_URL"
  235. echo $'Custom background image for gnusocial could not be downloaded'
  236. echo "1"
  237. return
  238. fi
  239. if grep -q "'img/custom" $gnusocial_config_file; then
  240. sed -i "s|'img/custom.*|'img/custom.${GNUSOCIAL_BACKGROUND_IMAGE_URL_EXT}';|g" $gnusocial_config_file
  241. fi
  242. fi
  243. echo "0"
  244. }
  245. function gnusocial_set_background_image {
  246. data=$(tempfile 2>/dev/null)
  247. trap "rm -f $data" 0 1 2 5 15
  248. dialog --title $"GNU Social" \
  249. --backtitle $"Freedombone Control Panel" \
  250. --inputbox $'Set a login screen background image URL' 10 60 2>$data
  251. sel=$?
  252. case $sel in
  253. 0)
  254. temp_background=$(<$data)
  255. if [ ${#temp_background} -gt 0 ]; then
  256. GNUSOCIAL_BACKGROUND_IMAGE_URL="$temp_background"
  257. write_config_param "GNUSOCIAL_BACKGROUND_IMAGE_URL" "$GNUSOCIAL_BACKGROUND_IMAGE_URL"
  258. if [[ $(gnusocial_set_background_image_from_url) == "0" ]]; then
  259. dialog --title $"Set GNU Social login background" \
  260. --msgbox $"The background image has been set" 6 60
  261. fi
  262. fi
  263. ;;
  264. esac
  265. }
  266. function gnusocial_set_welcome_message {
  267. data=$(tempfile 2>/dev/null)
  268. trap "rm -f $data" 0 1 2 5 15
  269. dialog --title $"GNU Social" \
  270. --backtitle $"Freedombone Control Panel" \
  271. --inputbox $'Set a welcome message, which can include html formatting' 10 60 2>$data
  272. sel=$?
  273. case $sel in
  274. 0)
  275. temp_welcome=$(<$data)
  276. if [ ${#temp_welcome} -gt 0 ]; then
  277. GNUSOCIAL_WELCOME_MESSAGE="$temp_welcome"
  278. gnusocial_config_file=/var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/config.php
  279. if grep -q "customwelcometext" $gnusocial_config_file; then
  280. write_config_param "GNUSOCIAL_WELCOME_MESSAGE" "$GNUSOCIAL_WELCOME_MESSAGE"
  281. sed -i "s|customwelcometext.*|customwelcometext']['en'] = '${GNUSOCIAL_WELCOME_MESSAGE}';|g" $gnusocial_config_file
  282. dialog --title $"Set GNU Social welcome message" \
  283. --msgbox $"Welcome message has been set" 6 60
  284. fi
  285. fi
  286. ;;
  287. esac
  288. }
  289. function configure_interactive_gnusocial {
  290. while true
  291. do
  292. data=$(tempfile 2>/dev/null)
  293. trap "rm -f $data" 0 1 2 5 15
  294. dialog --backtitle $"Freedombone Control Panel" \
  295. --title $"GNU Social" \
  296. --radiolist $"Choose an operation:" 12 70 3 \
  297. 1 $"Set a login screen background image" off \
  298. 2 $"Set a welcome message" off \
  299. 3 $"Exit" on 2> $data
  300. sel=$?
  301. case $sel in
  302. 1) return;;
  303. 255) return;;
  304. esac
  305. case $(cat $data) in
  306. 1) gnusocial_set_background_image;;
  307. 2) gnusocial_set_welcome_message;;
  308. 3) break;;
  309. esac
  310. done
  311. }
  312. function upgrade_gnusocial {
  313. if grep -q "gnusocial domain" $COMPLETION_FILE; then
  314. GNUSOCIAL_DOMAIN_NAME=$(get_completion_param "gnusocial domain")
  315. fi
  316. # update to the next commit
  317. function_check set_repo_commit
  318. set_repo_commit /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs "gnusocial commit" "$GNUSOCIAL_COMMIT" $GNUSOCIAL_REPO
  319. gnusocial_fix_endless_reloads
  320. # Ensure that installation script is removed
  321. if [ -f /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/install.php ]; then
  322. rm /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/install.php
  323. fi
  324. function_check gnusocial_running_script
  325. gnusocial_running_script
  326. }
  327. function backup_local_gnusocial {
  328. GNUSOCIAL_DOMAIN_NAME='gnusocial'
  329. if grep -q "gnusocial domain" $COMPLETION_FILE; then
  330. GNUSOCIAL_DOMAIN_NAME=$(get_completion_param "gnusocial domain")
  331. fi
  332. source_directory=/var/www/${GNUSOCIAL_DOMAIN_NAME}/htdocs
  333. if [ -d $source_directory ]; then
  334. dest_directory=gnusocial
  335. function_check suspend_site
  336. suspend_site ${GNUSOCIAL_DOMAIN_NAME}
  337. function_check backup_directory_to_usb
  338. backup_directory_to_usb $source_directory $dest_directory
  339. function_check backup_database_to_usb
  340. backup_database_to_usb gnusocial
  341. function_check restart_site
  342. restart_site
  343. fi
  344. }
  345. function restore_local_gnusocial {
  346. if ! grep -q "gnusocial domain" $COMPLETION_FILE; then
  347. return
  348. fi
  349. GNUSOCIAL_DOMAIN_NAME=$(get_completion_param "gnusocial domain")
  350. if [ $GNUSOCIAL_DOMAIN_NAME ]; then
  351. echo $"Restoring gnusocial"
  352. temp_restore_dir=/root/tempgnusocial
  353. gnusocial_dir=/var/www/${GNUSOCIAL_DOMAIN_NAME}/htdocs
  354. # stop the daemons
  355. cd $gnusocial_dir
  356. scripts/stopdaemons.sh
  357. function_check gnusocial_create_database
  358. gnusocial_create_database
  359. restore_database gnusocial ${GNUSOCIAL_DOMAIN_NAME}
  360. if [ -d $temp_restore_dir ]; then
  361. rm -rf $temp_restore_dir
  362. fi
  363. # start the daemons
  364. cd $gnusocial_dir
  365. scripts/startdaemons.sh
  366. echo $"Restore of gnusocial complete"
  367. fi
  368. }
  369. function backup_remote_gnusocial {
  370. if grep -q "gnusocial domain" $COMPLETION_FILE; then
  371. GNUSOCIAL_DOMAIN_NAME=$(get_completion_param "gnusocial domain")
  372. temp_backup_dir=/var/www/${GNUSOCIAL_DOMAIN_NAME}/htdocs
  373. if [ -d $temp_backup_dir ]; then
  374. function_check suspend_site
  375. suspend_site ${GNUSOCIAL_DOMAIN_NAME}
  376. function_check backup_database_to_friend
  377. backup_database_to_friend gnusocial
  378. echo $"Backing up GNU social installation"
  379. function_check backup_directory_to_friend
  380. backup_directory_to_friend $temp_backup_dir gnusocial
  381. function_check restart_site
  382. restart_site
  383. else
  384. echo $"gnusocial domain specified but not found in ${temp_backup_dir}"
  385. fi
  386. fi
  387. }
  388. function restore_remote_gnusocial {
  389. if grep -q "gnusocial domain" $COMPLETION_FILE; then
  390. echo $"Restoring gnusocial"
  391. GNUSOCIAL_DOMAIN_NAME=$(get_completion_param "gnusocial domain")
  392. # stop the daemons
  393. cd /var/www/${GNUSOCIAL_DOMAIN_NAME}/htdocs
  394. ./scripts/stopdaemons.sh
  395. function_check gnusocial_create_database
  396. gnusocial_create_database
  397. function_check restore_database_from_friend
  398. restore_database_from_friend gnusocial ${GNUSOCIAL_DOMAIN_NAME}
  399. if [ -d /root/tempgnusocial ]; then
  400. rm -rf /root/tempgnusocial
  401. fi
  402. # start the daemons
  403. cd /var/www/${GNUSOCIAL_DOMAIN_NAME}/htdocs
  404. ./scripts/startdaemons.sh
  405. echo $"Restore of gnusocial complete"
  406. fi
  407. }
  408. function remove_gnusocial {
  409. if [ ${#GNUSOCIAL_DOMAIN_NAME} -eq 0 ]; then
  410. return
  411. fi
  412. read_config_param "GNUSOCIAL_DOMAIN_NAME"
  413. read_config_param "MY_USERNAME"
  414. echo "Removing $GNUSOCIAL_DOMAIN_NAME"
  415. nginx_dissite $GNUSOCIAL_DOMAIN_NAME
  416. remove_certs $GNUSOCIAL_DOMAIN_NAME
  417. if [ -f /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/scripts/stopdaemons.sh ]; then
  418. cd /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/scripts
  419. ./scripts/stopdaemons.sh
  420. fi
  421. if [ -d /var/www/$GNUSOCIAL_DOMAIN_NAME ]; then
  422. rm -rf /var/www/$GNUSOCIAL_DOMAIN_NAME
  423. fi
  424. if [ -f /etc/nginx/sites-available/$GNUSOCIAL_DOMAIN_NAME ]; then
  425. rm /etc/nginx/sites-available/$GNUSOCIAL_DOMAIN_NAME
  426. fi
  427. function_check drop_database
  428. drop_database gnusocial
  429. function_check remove_onion_service
  430. remove_onion_service gnusocial ${GNUSOCIAL_ONION_PORT}
  431. if grep -q "gnusocial" /etc/crontab; then
  432. sed -i "/gnusocial/d" /etc/crontab
  433. fi
  434. remove_app gnusocial
  435. remove_completion_param install_gnusocial
  436. sed -i '/gnusocial/d' $COMPLETION_FILE
  437. if [ -f /etc/cron.hourly/gnusocial-daemons ]; then
  438. rm /etc/cron.hourly/gnusocial-daemons
  439. fi
  440. remove_backup_database_local gnusocial
  441. function_check remove_ddns_domain
  442. remove_ddns_domain $GNUSOCIAL_DOMAIN_NAME
  443. }
  444. function install_gnusocial_main {
  445. if [ ! $GNUSOCIAL_DOMAIN_NAME ]; then
  446. echo $'No domain name was given for gnusocial'
  447. exit 7359
  448. fi
  449. if [[ $(app_is_installed gnusocial_main) == "1" ]]; then
  450. return
  451. fi
  452. function_check gnusocial_running_script
  453. gnusocial_running_script
  454. function_check install_mariadb
  455. install_mariadb
  456. function_check get_mariadb_password
  457. get_mariadb_password
  458. function_check repair_databases_script
  459. repair_databases_script
  460. apt-get -yq install php-gettext php5-curl php5-gd php5-mysql git curl php-xml-parser
  461. apt-get -yq install php5-memcached php5-intl
  462. if [ ! -d /var/www/$GNUSOCIAL_DOMAIN_NAME ]; then
  463. mkdir /var/www/$GNUSOCIAL_DOMAIN_NAME
  464. fi
  465. if [ ! -d /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs ]; then
  466. function_check git_clone
  467. git_clone $GNUSOCIAL_REPO /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs
  468. if [ ! -d /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs ]; then
  469. echo $'Unable to clone gnusocial repo'
  470. exit 87525
  471. fi
  472. fi
  473. cd /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs
  474. git checkout $GNUSOCIAL_COMMIT -b $GNUSOCIAL_COMMIT
  475. set_completion_param "gnusocial commit" "$GNUSOCIAL_COMMIT"
  476. gnusocial_fix_endless_reloads
  477. chmod g+w /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs
  478. chmod a+w /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/avatar
  479. chmod a+w /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/file
  480. chown -R www-data:www-data /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs
  481. chmod +x /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/scripts/maildaemon.php
  482. function_check gnusocial_create_database
  483. gnusocial_create_database
  484. if [ ! -f "/etc/aliases" ]; then
  485. touch /etc/aliases
  486. fi
  487. if ! grep -q "www-data: root" /etc/aliases; then
  488. echo 'www-data: root' >> /etc/aliases
  489. fi
  490. if ! grep -q "/var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/scripts/maildaemon.php" /etc/aliases; then
  491. echo "*: /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/scripts/maildaemon.php" >> /etc/aliases
  492. fi
  493. function_check add_ddns_domain
  494. add_ddns_domain $GNUSOCIAL_DOMAIN_NAME
  495. gnusocial_nginx_site=/etc/nginx/sites-available/$GNUSOCIAL_DOMAIN_NAME
  496. if [[ $ONION_ONLY == "no" ]]; then
  497. function_check nginx_http_redirect
  498. nginx_http_redirect $GNUSOCIAL_DOMAIN_NAME
  499. echo 'server {' >> $gnusocial_nginx_site
  500. echo ' listen 443 ssl;' >> $gnusocial_nginx_site
  501. echo ' listen [::]:443 ssl;' >> $gnusocial_nginx_site
  502. echo " server_name $GNUSOCIAL_DOMAIN_NAME;" >> $gnusocial_nginx_site
  503. echo '' >> $gnusocial_nginx_site
  504. echo ' # Security' >> $gnusocial_nginx_site
  505. function_check nginx_ssl
  506. nginx_ssl $GNUSOCIAL_DOMAIN_NAME
  507. function_check nginx_disable_sniffing
  508. nginx_disable_sniffing $GNUSOCIAL_DOMAIN_NAME
  509. echo ' add_header Strict-Transport-Security max-age=15768000;' >> $gnusocial_nginx_site
  510. echo '' >> $gnusocial_nginx_site
  511. echo ' # Logs' >> $gnusocial_nginx_site
  512. echo ' access_log /dev/null;' >> $gnusocial_nginx_site
  513. echo ' error_log /dev/null;' >> $gnusocial_nginx_site
  514. echo '' >> $gnusocial_nginx_site
  515. echo ' # Root' >> $gnusocial_nginx_site
  516. echo " root /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs;" >> $gnusocial_nginx_site
  517. echo '' >> $gnusocial_nginx_site
  518. echo ' # Index' >> $gnusocial_nginx_site
  519. echo ' index index.php;' >> $gnusocial_nginx_site
  520. echo '' >> $gnusocial_nginx_site
  521. echo ' # PHP' >> $gnusocial_nginx_site
  522. echo ' location ~ \.php {' >> $gnusocial_nginx_site
  523. echo ' include snippets/fastcgi-php.conf;' >> $gnusocial_nginx_site
  524. echo ' fastcgi_pass unix:/var/run/php5-fpm.sock;' >> $gnusocial_nginx_site
  525. echo ' }' >> $gnusocial_nginx_site
  526. echo '' >> $gnusocial_nginx_site
  527. echo ' # Location' >> $gnusocial_nginx_site
  528. echo ' location / {' >> $gnusocial_nginx_site
  529. function_check nginx_limits
  530. nginx_limits $GNUSOCIAL_DOMAIN_NAME '15m'
  531. echo ' try_files $uri $uri/ @gnusocial;' >> $gnusocial_nginx_site
  532. echo ' }' >> $gnusocial_nginx_site
  533. echo '' >> $gnusocial_nginx_site
  534. echo ' # Fancy URLs' >> $gnusocial_nginx_site
  535. echo ' location @gnusocial {' >> $gnusocial_nginx_site
  536. echo ' rewrite ^(.*)$ /index.php?p=$1 last;' >> $gnusocial_nginx_site
  537. echo ' }' >> $gnusocial_nginx_site
  538. echo '' >> $gnusocial_nginx_site
  539. echo ' # Restrict access that is unnecessary anyway' >> $gnusocial_nginx_site
  540. echo ' location ~ /\.(ht|git) {' >> $gnusocial_nginx_site
  541. echo ' deny all;' >> $gnusocial_nginx_site
  542. echo ' }' >> $gnusocial_nginx_site
  543. echo '' >> $gnusocial_nginx_site
  544. # DO NOT ENABLE KEYBASE. gnusocial really doesn't like having a .well-known directory
  545. echo '}' >> $gnusocial_nginx_site
  546. else
  547. echo -n '' > $gnusocial_nginx_site
  548. fi
  549. echo 'server {' >> $gnusocial_nginx_site
  550. echo " listen 127.0.0.1:$GNUSOCIAL_ONION_PORT default_server;" >> $gnusocial_nginx_site
  551. echo " server_name $GNUSOCIAL_DOMAIN_NAME;" >> $gnusocial_nginx_site
  552. echo '' >> $gnusocial_nginx_site
  553. function_check nginx_disable_sniffing
  554. nginx_disable_sniffing $GNUSOCIAL_DOMAIN_NAME
  555. echo '' >> $gnusocial_nginx_site
  556. echo ' # Logs' >> $gnusocial_nginx_site
  557. echo ' access_log /dev/null;' >> $gnusocial_nginx_site
  558. echo ' error_log /dev/null;' >> $gnusocial_nginx_site
  559. echo '' >> $gnusocial_nginx_site
  560. echo ' # Root' >> $gnusocial_nginx_site
  561. echo " root /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs;" >> $gnusocial_nginx_site
  562. echo '' >> $gnusocial_nginx_site
  563. echo ' # Index' >> $gnusocial_nginx_site
  564. echo ' index index.php;' >> $gnusocial_nginx_site
  565. echo '' >> $gnusocial_nginx_site
  566. echo ' # PHP' >> $gnusocial_nginx_site
  567. echo ' location ~ \.php {' >> $gnusocial_nginx_site
  568. echo ' include snippets/fastcgi-php.conf;' >> $gnusocial_nginx_site
  569. echo ' fastcgi_pass unix:/var/run/php5-fpm.sock;' >> $gnusocial_nginx_site
  570. echo ' }' >> $gnusocial_nginx_site
  571. echo '' >> $gnusocial_nginx_site
  572. echo ' # Location' >> $gnusocial_nginx_site
  573. echo ' location / {' >> $gnusocial_nginx_site
  574. function_check nginx_limits
  575. nginx_limits $GNUSOCIAL_DOMAIN_NAME '15m'
  576. echo ' try_files $uri $uri/ @gnusocial;' >> $gnusocial_nginx_site
  577. echo ' }' >> $gnusocial_nginx_site
  578. echo '' >> $gnusocial_nginx_site
  579. echo ' # Fancy URLs' >> $gnusocial_nginx_site
  580. echo ' location @gnusocial {' >> $gnusocial_nginx_site
  581. echo ' rewrite ^(.*)$ /index.php?p=$1 last;' >> $gnusocial_nginx_site
  582. echo ' }' >> $gnusocial_nginx_site
  583. echo '' >> $gnusocial_nginx_site
  584. echo ' # Restrict access that is unnecessary anyway' >> $gnusocial_nginx_site
  585. echo ' location ~ /\.(ht|git) {' >> $gnusocial_nginx_site
  586. echo ' deny all;' >> $gnusocial_nginx_site
  587. echo ' }' >> $gnusocial_nginx_site
  588. echo '' >> $gnusocial_nginx_site
  589. # DO NOT ENABLE KEYBASE. gnusocial really doesn't like having a .well-known directory
  590. echo '}' >> $gnusocial_nginx_site
  591. function_check configure_php
  592. configure_php
  593. function_check create_site_certificate
  594. create_site_certificate $GNUSOCIAL_DOMAIN_NAME 'yes'
  595. # Ensure that the database gets backed up locally, if remote
  596. # backups are not being used
  597. function_check backup_databases_script_header
  598. backup_databases_script_header
  599. function_check backup_database_local
  600. backup_database_local gnusocial
  601. function_check nginx_ensite
  602. nginx_ensite $GNUSOCIAL_DOMAIN_NAME
  603. # NOTE: For the typical case always enable SSL and only
  604. # disable it if in onion only mode. This is due to complexities
  605. # with the way URLs are generated by gnusocial
  606. gnusocial_ssl='always'
  607. if [[ $ONION_ONLY != 'no' ]]; then
  608. gnusocial_ssl='never'
  609. fi
  610. GNUSOCIAL_ONION_HOSTNAME=$(add_onion_service gnusocial 80 ${GNUSOCIAL_ONION_PORT})
  611. GNUSOCIAL_SERVER=${GNUSOCIAL_DOMAIN_NAME}
  612. if [[ $ONION_ONLY != 'no' ]]; then
  613. GNUSOCIAL_SERVER=${GNUSOCIAL_ONION_HOSTNAME}
  614. fi
  615. # Create the configuration
  616. gnusocial_installer=/var/www/${GNUSOCIAL_DOMAIN_NAME}/htdocs/scripts/install_cli.php
  617. if [ ! -f $gnusocial_installer ]; then
  618. rm -rf /var/www/$GNUSOCIAL_DOMAIN_NAME
  619. echo $'No gnusocial commandline installer found'
  620. exit 53026
  621. fi
  622. ${gnusocial_installer} --server "${GNUSOCIAL_SERVER}" \
  623. --host="localhost" --database="gnusocial" \
  624. --dbtype=mysql --username="root" -v \
  625. --password="$MARIADB_PASSWORD" \
  626. --sitename=$"GNU Social" --fancy='yes' \
  627. --admin-nick="$MY_USERNAME" \
  628. --admin-pass="$GNUSOCIAL_ADMIN_PASSWORD" \
  629. --site-profile="community" \
  630. --ssl=${gnusocial_ssl}
  631. # There can be a lot of warnings here so the return value check is disabled
  632. #if [ ! "$?" = "0" ]; then
  633. # # failed to install
  634. # echo $'Could not install GNU Social'
  635. # exit 72357
  636. #fi
  637. # check gnusocial has a config file
  638. gnusocial_config_file=/var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/config.php
  639. if [ ! -f $gnusocial_config_file ]; then
  640. drop_database gnusocial
  641. rm -rf /var/www/$GNUSOCIAL_DOMAIN_NAME
  642. echo $'Gnusocial config.php not found'
  643. exit 87586
  644. fi
  645. # Some useful settings
  646. if ! grep -q "Recommended GNU social settings" $gnusocial_config_file; then
  647. echo "" >> $gnusocial_config_file
  648. echo "// Recommended GNU social settings" >> $gnusocial_config_file
  649. echo "\$config['thumbnail']['maxsize'] = 3000;" >> $gnusocial_config_file
  650. echo "\$config['profile']['delete'] = true;" >> $gnusocial_config_file
  651. echo "\$config['profile']['changenick'] = true;" >> $gnusocial_config_file
  652. echo "\$config['public']['localonly'] = false;" >> $gnusocial_config_file
  653. echo "addPlugin('StoreRemoteMedia');" >> $gnusocial_config_file
  654. echo "\$config['queue']['enabled'] = true;" >> $gnusocial_config_file
  655. echo "\$config['queue']['daemon'] = true;" >> $gnusocial_config_file
  656. echo "\$config['ostatus']['hub_retries'] = 3;" >> $gnusocial_config_file
  657. fi
  658. # turn off logging
  659. echo "\$config['site']['logfile'] = '/dev/null';" >> $gnusocial_config_file
  660. echo "\$config['mail']['domain'] = '${DEFAULT_DOMAIN_NAME}';" >> $gnusocial_config_file
  661. # This improves performance
  662. sed -i "s|//\$config\['db'\]\['schemacheck'\].*|\$config\['db'\]\['schemacheck'\] = 'script';|g" $gnusocial_config_file
  663. systemctl restart php5-fpm
  664. systemctl restart nginx
  665. ${PROJECT_NAME}-addemail -u $MY_USERNAME -e "noreply@$GNUSOCIAL_DOMAIN_NAME" -g gnusocial --public no
  666. ${PROJECT_NAME}-pass -u $MY_USERNAME -a gnusocial -p "$GNUSOCIAL_ADMIN_PASSWORD"
  667. set_completion_param "gnusocial domain" "$GNUSOCIAL_DOMAIN_NAME"
  668. install_completed gnusocial_main
  669. }
  670. function install_gnusocial_plugin_sharings {
  671. if [ ! -d /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/local/plugins ]; then
  672. echo $'No local/plugins directory found for the gnusocial'
  673. exit 72945
  674. fi
  675. apt-get -yq install liblocale-msgfmt-perl gettext
  676. # update to the next commit
  677. function_check set_repo_commit
  678. set_repo_commit /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/local/plugins "gnusocial sharings plugin commit" "$SHARINGS_COMMIT" $SHARINGS_REPO
  679. if [[ $(app_is_installed gnusocial_plugin_sharings) == "1" ]]; then
  680. return
  681. fi
  682. cd /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/local/plugins
  683. function_check git_clone
  684. git_clone $SHARINGS_REPO Sharings
  685. if [ ! -d /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/local/plugins/Sharings ]; then
  686. echo $'Unable to clone gnusocial sharings plugin'
  687. exit 36738
  688. fi
  689. cd /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/local/plugins/Sharings
  690. git stash
  691. git checkout master
  692. git branch -D $SHARINGS_COMMIT
  693. git checkout $SHARINGS_COMMIT -b $SHARINGS_COMMIT
  694. # enable the plugin
  695. if ! grep -q "addPlugin('Sharings');" /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/config.php; then
  696. echo "addPlugin('Sharings');" >> /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/config.php
  697. fi
  698. cd /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs
  699. php scripts/checkschema.php
  700. cd /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/local/plugins/Sharings
  701. php scripts/seedsharings.php
  702. cd /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs
  703. php scripts/checkschema.php
  704. # Languages
  705. cd /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/local/plugins/Sharings/locale/en/LC_MESSAGES
  706. msgfmt -o Sharings.mo Sharings.po
  707. if [ ! -f Sharings.po ]; then
  708. echo $'English translations for gnusocial sharings plugin were not created'
  709. exit 84352
  710. fi
  711. cd /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/local/plugins/Sharings/locale/en_GB/LC_MESSAGES
  712. msgfmt -o Sharings.mo Sharings.po
  713. if [ ! -f Sharings.po ]; then
  714. echo $'English (GB) translations for gnusocial sharings plugin were not created'
  715. exit 84352
  716. fi
  717. cd /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/local/plugins/Sharings/locale/en_US/LC_MESSAGES
  718. msgfmt -o Sharings.mo Sharings.po
  719. if [ ! -f Sharings.po ]; then
  720. echo $'English (US) translations for gnusocial sharings plugin were not created'
  721. exit 84352
  722. fi
  723. # Looks like this update function isn't supported by the current php version
  724. sed -i 's|ActivityVerb::UPDATE, ||g' /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/local/plugins/Sharings/SharingsPlugin.php
  725. chown -R www-data:www-data /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs
  726. set_completion_param gnusocial "sharings plugin commit" "$SHARINGS_COMMIT"
  727. install_completed gnusocial_plugin_sharings
  728. }
  729. function install_gnusocial_plugin_sharings_theme {
  730. if [ ! -d /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/local/plugins ]; then
  731. echo $'No local/plugins directory found for the gnusocial'
  732. exit 74458
  733. fi
  734. # update to the next commit
  735. function_check set_repo_commit
  736. set_repo_commit /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/local/plugins "gnusocial sharings theme plugin commit" "$SHARINGS_THEME_COMMIT" $SHARINGS_THEME_REPO
  737. if [[ $(app_is_installed gnusocial_plugin_sharings_theme) == "1" ]]; then
  738. return
  739. fi
  740. cd /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/local/plugins
  741. function_check git_clone
  742. git_clone $SHARINGS_THEME_REPO SharingsTheme
  743. if [ ! -d /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/local/plugins/SharingsTheme ]; then
  744. echo $'Unable to clone gnusocial sharings plugin theme'
  745. exit 639253
  746. fi
  747. cd /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/local/plugins/SharingsTheme
  748. git stash
  749. git checkout master
  750. git branch -D $SHARINGS_THEME_COMMIT
  751. git checkout $SHARINGS_THEME_COMMIT -b $SHARINGS_THEME_COMMIT
  752. # enable the plugin
  753. if ! grep -q "addPlugin('SharingsTheme');" /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/config.php; then
  754. echo "addPlugin('SharingsTheme');" >> /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/config.php
  755. fi
  756. cd /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs
  757. php scripts/checkschema.php
  758. chown -R www-data:www-data /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs
  759. set_completion_param "gnusocial sharings plugin theme commit" "$SHARINGS_THEME_COMMIT"
  760. install_completed gnusocial_plugin_sharings_theme
  761. }
  762. function expire_gnusocial_posts {
  763. # To prevent the database size from growing endlessly this script expires posts
  764. # after a number of months
  765. if [ ! -d /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs ]; then
  766. return
  767. fi
  768. echo '<?php' > $gnusocial_expire_script
  769. echo '' >> $gnusocial_expire_script
  770. echo '// gnusocial post expiry script, based on StatExpire by Tony Baldwin' >> $gnusocial_expire_script
  771. echo '// https://github.com/tonybaldwin/statexpire' >> $gnusocial_expire_script
  772. echo '' >> $gnusocial_expire_script
  773. echo '$oldate=date(("Y-m-d"), strtotime("-3 months"));' >> $gnusocial_expire_script
  774. echo '$username="root";' >> $gnusocial_expire_script
  775. echo "\$password=shell_exec('${PROJECT_NAME}-pass -u root -a mariadb');" >> $gnusocial_expire_script
  776. echo '$database="gnusocial";' >> $gnusocial_expire_script
  777. echo '' >> $gnusocial_expire_script
  778. echo 'if (!$link = mysql_connect("localhost", $username, $password)) {' >> $gnusocial_expire_script
  779. echo ' echo "Could not connect to mariadb";' >> $gnusocial_expire_script
  780. echo ' exit;' >> $gnusocial_expire_script
  781. echo '}' >> $gnusocial_expire_script
  782. echo '' >> $gnusocial_expire_script
  783. echo 'if (!mysql_select_db($database, $link)) {' >> $gnusocial_expire_script
  784. echo ' echo "Could not select gnusocial database";' >> $gnusocial_expire_script
  785. echo ' exit;' >> $gnusocial_expire_script
  786. echo '}' >> $gnusocial_expire_script
  787. echo '' >> $gnusocial_expire_script
  788. echo "\$notice_query=\"DELETE FROM notice WHERE created <= '\$oldate 01:01:01'\";" >> $gnusocial_expire_script
  789. echo "\$conversation_query=\"DELETE FROM conversation WHERE created <= '$oldate 01:01:01'\";" >> $gnusocial_expire_script
  790. echo "\$reply_query=\"DELETE FROM reply WHERE modified <= '\$oldate 01:01:01'\";" >> $gnusocial_expire_script
  791. echo '' >> $gnusocial_expire_script
  792. echo 'mysql_query($notice_query);' >> $gnusocial_expire_script
  793. echo '$rowaff1=mysql_affected_rows();' >> $gnusocial_expire_script
  794. echo 'mysql_query($conversation_query);' >> $gnusocial_expire_script
  795. echo '$rowaff2=mysql_affected_rows();' >> $gnusocial_expire_script
  796. echo 'mysql_query($reply_query);' >> $gnusocial_expire_script
  797. echo '$rowaff3=mysql_affected_rows();' >> $gnusocial_expire_script
  798. echo 'mysql_close();' >> $gnusocial_expire_script
  799. echo '' >> $gnusocial_expire_script
  800. echo 'echo "Expire gnusocial posts: $rowaff1 notices, $rowaff2 conversations, and $rowaff3 replies deleted from database.\n";' >> $gnusocial_expire_script
  801. chmod +x $gnusocial_expire_script
  802. # Add a cron job
  803. if ! grep -q "$gnusocial_expire_script" /etc/crontab; then
  804. echo "10 3 5 * * root /usr/bin/timeout 500 /usr/bin/php $gnusocial_expire_script" >> /etc/crontab
  805. fi
  806. # remove old expire script
  807. if [ -f /etc/cron.weekly/clear-gnusocial-database ]; then
  808. rm /etc/cron.weekly/clear-gnusocial-database
  809. fi
  810. }
  811. function install_gnusocial_theme {
  812. # update to the next commit
  813. function_check set_repo_commit
  814. set_repo_commit /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/local/plugins/Qvitter "gnusocial theme commit" "$GNUSOCIAL_THEME_COMMIT" $GNUSOCIAL_THEME_REPO
  815. # customise with project logo
  816. if [ -f /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/local/plugins/Qvitter/img/sprite.png ]; then
  817. if [ -f ~/freedombone/img/gnusocial_sprite.png ]; then
  818. cp ~/freedombone/img/gnusocial_sprite.png /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/local/plugins/Qvitter/img/sprite.png
  819. else
  820. if [ -f /home/$MY_USERNAME/freedombone/img/gnusocial_sprite.png ]; then
  821. cp /home/$MY_USERNAME/freedombone/img/gnusocial_sprite.png /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/local/plugins/Qvitter/img/sprite.png
  822. fi
  823. fi
  824. fi
  825. if [[ $(app_is_installed gnusocial_theme) == "1" ]]; then
  826. return
  827. fi
  828. apt-get -yq install wget
  829. if [ ! -d /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/local/plugins ]; then
  830. mkdir -p /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/local/plugins
  831. fi
  832. cd /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/local/plugins
  833. function_check git_clone
  834. git_clone $GNUSOCIAL_THEME_REPO Qvitter
  835. cd /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/local/plugins/Qvitter
  836. git checkout $GNUSOCIAL_THEME_COMMIT -b $GNUSOCIAL_THEME_COMMIT
  837. # download a custom background image
  838. if [[ $(gnusocial_set_background_image_from_url) != "0" ]]; then
  839. exit 356723
  840. fi
  841. if [ $GNUSOCIAL_BACKGROUND_IMAGE_URL ]; then
  842. filename=$(basename "$GNUSOCIAL_BACKGROUND_IMAGE_URL")
  843. GNUSOCIAL_BACKGROUND_IMAGE_URL_EXT="${filename##*.}"
  844. fi
  845. gnusocial_config_file=/var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/config.php
  846. if ! grep -q "addPlugin('Qvitter')" $gnusocial_config_file; then
  847. GNUSOCIAL_WELCOME_MESSAGE=$(echo $GNUSOCIAL_WELCOME_MESSAGE | sed "s|\$GNUSOCIAL_DOMAIN_NAME|$GNUSOCIAL_DOMAIN_NAME|g")
  848. echo "" >> $gnusocial_config_file
  849. echo "// Qvitter settings" >> $gnusocial_config_file
  850. echo "addPlugin('Qvitter');" >> $gnusocial_config_file
  851. echo "\$config['site']['qvitter']['enabledbydefault'] = true;" >> $gnusocial_config_file
  852. echo "\$config['site']['qvitter']['defaultbackgroundcolor'] = '#f4f4f4';" >> $gnusocial_config_file
  853. echo "\$config['site']['qvitter']['defaultlinkcolor'] = '#0084B4';" >> $gnusocial_config_file
  854. echo "\$config['site']['qvitter']['timebetweenpolling'] = 30000; // 30 secs" >> $gnusocial_config_file
  855. if [[ $ONION_ONLY != 'no' ]]; then
  856. echo "\$config['site']['qvitter']['urlshortenerapiurl'] = 'http://qttr.at/shortener.php';" >> $gnusocial_config_file
  857. echo "\$config['site']['qvitter']['urlshortenersignature'] = 'b6afeec983';" >> $gnusocial_config_file
  858. fi
  859. if [ $GNUSOCIAL_BACKGROUND_IMAGE_URL ]; then
  860. echo "\$config['site']['qvitter']['sitebackground'] = 'img/custom.${GNUSOCIAL_BACKGROUND_IMAGE_URL_EXT}';" >> $gnusocial_config_file
  861. else
  862. echo "\$config['site']['qvitter']['sitebackground'] = 'img/vagnsmossen.jpg';" >> $gnusocial_config_file
  863. fi
  864. echo "\$config['site']['qvitter']['favicon'] = 'img/favicon.ico?v=4';" >> $gnusocial_config_file
  865. echo "\$config['site']['qvitter']['sprite'] = Plugin::staticPath('Qvitter', '').'img/sprite.png?v=40';" >> $gnusocial_config_file
  866. echo "\$config['site']['qvitter']['enablewelcometext'] = true;" >> $gnusocial_config_file
  867. echo "\$config['site']['qvitter']['customwelcometext']['en'] = '$GNUSOCIAL_WELCOME_MESSAGE';" >> $gnusocial_config_file
  868. echo "\$config['site']['qvitter']['customwelcometext']['de'] = '$GNUSOCIAL_WELCOME_MESSAGE';" >> $gnusocial_config_file
  869. echo "\$config['site']['qvitter']['customwelcometext']['fr'] = '$GNUSOCIAL_WELCOME_MESSAGE';" >> $gnusocial_config_file
  870. echo "\$config['site']['qvitter']['customwelcometext']['es'] = '$GNUSOCIAL_WELCOME_MESSAGE';" >> $gnusocial_config_file
  871. echo "\$config['site']['qvitter']['blocked_ips'] = array();" >> $gnusocial_config_file
  872. else
  873. if [ $GNUSOCIAL_BACKGROUND_IMAGE_URL_EXT ]; then
  874. if [ -f img/custom.${GNUSOCIAL_BACKGROUND_IMAGE_URL_EXT} ]; then
  875. sed -i "s|\$config['site']['qvitter']['sitebackground'].*|\$config['site']['qvitter']['sitebackground'] = 'img/custom.${GNUSOCIAL_BACKGROUND_IMAGE_URL_EXT}';|g" $gnusocial_config_file
  876. fi
  877. fi
  878. fi
  879. # customise with project logo
  880. if [ -f /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/local/plugins/Qvitter/img/sprite.png ]; then
  881. if [ -f ~/freedombone/img/gnusocial_sprite.png ]; then
  882. cp ~/freedombone/img/gnusocial_sprite.png /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/local/plugins/Qvitter/img/sprite.png
  883. fi
  884. fi
  885. set_completion_param "gnusocial theme commit" "$GNUSOCIAL_THEME_COMMIT"
  886. chown -R www-data:www-data /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs
  887. install_completed gnusocial_theme
  888. }
  889. function install_gnusocial_markdown {
  890. GNUSOCIAL_PATH=/var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs
  891. # update to the next commit
  892. function_check set_repo_commit
  893. set_repo_commit $GNUSOCIAL_PATH/local/plugins/Markdown "gnusocial Markdown commit" "$GNUSOCIAL_MARKDOWN_COMMIT" $GNUSOCIAL_MARKDOWN_REPO
  894. if [[ $(app_is_installed gnusocial_markdown) == "1" ]]; then
  895. return
  896. fi
  897. if [ -d $GNUSOCIAL_PATH/local/plugins/Markdown ]; then
  898. rm -rf $GNUSOCIAL_PATH/local/plugins/Markdown
  899. fi
  900. if [ ! -d $GNUSOCIAL_PATH/local/plugins ]; then
  901. mkdir -p $GNUSOCIAL_PATH/local/plugins
  902. fi
  903. cd $GNUSOCIAL_PATH/local/plugins
  904. function_check git_clone
  905. git_clone $GNUSOCIAL_MARKDOWN_REPO Markdown
  906. cd $GNUSOCIAL_PATH/local/plugins/Markdown
  907. git checkout $GNUSOCIAL_MARKDOWN_COMMIT -b $GNUSOCIAL_MARKDOWN_COMMIT
  908. gnusocial_config_file=$GNUSOCIAL_PATH/config.php
  909. if ! grep -q "addPlugin('Markdown'" $gnusocial_config_file; then
  910. echo "" >> $gnusocial_config_file
  911. echo "// Markdown settings" >> $gnusocial_config_file
  912. echo "addPlugin('Markdown');" >> $gnusocial_config_file
  913. fi
  914. set_completion_param "gnusocial markdown commit" "$GNUSOCIAL_MARKDOWN_COMMIT"
  915. chown -R www-data:www-data $GNUSOCIAL_PATH
  916. install_completed gnusocial_markdown
  917. }
  918. function install_gnusocial_plugin_nsfw {
  919. if [ ! -d /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/local/plugins ]; then
  920. echo $'No local/plugins directory found for the gnusocial'
  921. exit 37252
  922. fi
  923. # update to the next commit
  924. function_check set_repo_commit
  925. set_repo_commit /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/local/plugins "gnusocial NSFW plugin commit" "$GNUSOCIAL_NSFW_COMMIT" $GNUSOCIAL_NSFW_REPO
  926. if [[ $(is_completed $FUNCNAME) == "1" ]]; then
  927. return
  928. fi
  929. cd /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/local/plugins
  930. function_check git_clone
  931. git_clone $GNUSOCIAL_NSFW_REPO SensitiveContent
  932. if [ ! -d /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/local/plugins/SensitiveContent ]; then
  933. echo $'Unable to clone gnusocial NSFW plugin'
  934. exit 36738
  935. fi
  936. cd /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/local/plugins/SensitiveContent
  937. git stash
  938. git checkout master
  939. git branch -D $GNUSOCIAL_NSFW_COMMIT
  940. git checkout $GNUSOCIAL_NSFW_COMMIT -b $GNUSOCIAL_NSFW_COMMIT
  941. # enable the plugin
  942. if ! grep -q "addPlugin('SensitiveContent');" /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/config.php; then
  943. echo "addPlugin('SensitiveContent');" >> /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/config.php
  944. fi
  945. cd /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs
  946. php scripts/checkschema.php
  947. chown -R www-data:www-data /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs
  948. set_completion_param "gnusocial NSFW plugin commit" "$GNUSOCIAL_NSFW_COMMIT"
  949. install_completed gnusocial_plugin_nsfw
  950. }
  951. function install_gnusocial {
  952. if [ ! $ONION_ONLY ]; then
  953. ONION_ONLY='no'
  954. fi
  955. install_gnusocial_main
  956. expire_gnusocial_posts
  957. install_gnusocial_theme
  958. install_gnusocial_markdown
  959. install_gnusocial_plugin_sharings
  960. install_gnusocial_plugin_sharings_theme
  961. install_gnusocial_plugin_nsfw
  962. # unleash the daemons!
  963. /etc/cron.hourly/gnusocial-daemons
  964. APP_INSTALLED=1
  965. }
  966. # NOTE: deliberately there is no "exit 0"